Index: /trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/basexecut.cc	(revision 1882)
+++ /trunk/SophyaPI/PIext/basexecut.cc	(revision 1883)
@@ -1320,4 +1320,7 @@
 usage += "o <Alt>I : Shows (or updates) a text info window on the selected rectangle \n";
 usage += "o <Alt>M : Activate/Deactivate a measurement cursor on Button-1";
+usage += "o <Alt>L : Deactivate DX,DY print (see below)";
+usage += ">>>> Mouse + Keyboard controls : \n";
+usage += "o Button-1 + <Alt>K : Set (reset) the reference point for DX,DY print \n";
 piac->RegisterHelp(kw, usage, grp);
 
Index: /trunk/SophyaPI/PIext/pihisto2d.cc
===================================================================
--- /trunk/SophyaPI/PIext/pihisto2d.cc	(revision 1882)
+++ /trunk/SophyaPI/PIext/pihisto2d.cc	(revision 1883)
@@ -364,5 +364,5 @@
   if(i<0 || i>=h->NBinX() || j<0 || j>=h->NBinY()) info += " ???";
   else {
-    sprintf(str," v= %g",x,y,(*h)(i,j));
+    sprintf(str," v= %g",(*h)(i,j));
     info += str;
   }
@@ -450,149 +450,4 @@
 return np;
 }
-
-
-/*
-// NOT USED ANYMORE... KEEP IT FOR MEMORY
-/////////////////////////////////////////////////////////////////
-//  Classe PIH2DWdg
-/////////////////////////////////////////////////////////////////
-
-//++
-// Class	PIH2DWdg
-// Lib		PIext
-// include	pihisto2d.h
-//
-//	Classe de composantes graphiques permettant la manipulation
-//	de traceur d'histos 2D ("PIHisto2D")
-//--
-//++
-// Links	Parents
-// PIScDrawWdg
-//--
-//++
-// Links	Voir aussi
-// PIHisto2D
-//--
-
-//++
-// Titre	Constructeur, méthodes
-//--
-
-static H2WinArg* h2dWinArg=NULL;
-static int nb_h2dWinArg = 0;
-
-//++
-PIH2DWdg::PIH2DWdg(PIContainerGen *par, const char *nom, int sx, int sy, int px, int py)
-//
-//	Createur d'un Widget de dessin d'histogramme 2D.
-//	Le menu pour choisir les options d'affichage apparait
-//	suite a ALT-O (cf H2WinArg::H2WinArg).
-//--
-: PIScDrawWdg(par,nom,sx,sy,px,py)
-{
-if(!h2dWinArg) h2dWinArg = new H2WinArg(this);
-nb_h2dWinArg++;
-if(dbg) printf("PIH2DWdg::PIH2DWdg %p h2dWinArg=%p %d\n"
-              ,this,h2dWinArg,nb_h2dWinArg);
-mPih = NULL;
-// Pour afficher le menu option de trace
-ActivateButton(3);
-}
-
-//++
-PIH2DWdg::~PIH2DWdg()
-//
-//	Destructeur.
-//--
-{
-nb_h2dWinArg--;
-if(nb_h2dWinArg == 0) {
-  h2dWinArg->Hide();
-  delete h2dWinArg;
-  h2dWinArg=NULL;
-}
-if(dbg) printf("PIH2DWdg::~PIH2DWdg h2dWinArg=%p %d\n"
-              ,h2dWinArg,nb_h2dWinArg);
-if(mPih) delete mPih;
-}
-
-//++
-void PIH2DWdg::SetHisto(Histo2D* histo)
-//
-//	Pour connecter un histogramme 2D au Widget.
-//--
-{
-if(!histo) return;
-if(mPih)  delete mPih;
-mPih = new PIHisto2D(histo, true);
-AddScDrawer(mPih);
-if(dbg) printf("PIH2DWdg::SetHisto mPih=%p\n",mPih);
-}
-
-//++
-void PIH2DWdg::SetPIHisto(PIHisto2D* pih2)
-//
-//	Pour connecter un traceur (Drawer) d'histo 2D au Widget.
-//--
-{
-if(!pih2) return;
-if(mPih)  delete mPih;
-mPih = pih2;
-AddScDrawer(mPih);
-if(dbg) printf("PIH2DWdg::SetPIHisto mPih=%p\n",mPih);
-}
-
-//++
-string  PIH2DWdg::GetClickText(double x, double y)
-//
-//	Quand on click (and drag) le bouton-1, affichage
-//	des positions x,y et de la valeur du bin de l'histogramme 2D.
-//--
-{
-int i,j;
-char str[128];
-
-if((!mPih) || (!mPih->Histogram())) {
-  sprintf(str,"X=%g Y=%g ???",x,y);
-  return((string)str);
-}
-
-Histo2D* h = mPih->Histogram();
-
-h->FindBin(x,y,i,j);
-if(i<0 || i>=h->NBinX() || j<0 || j>=h->NBinY())
-  sprintf(str,"x= %g y= %g ???",x,y);
-else sprintf(str,"x= %g y= %g v= %g",x,y,(*h)(i,j));
-
-return((string)str);
-}
-
-//++
-void PIH2DWdg::ActivateSpecializedControls()
-//	Pour activer les contrôles spécifiques pour l'affichage Histo-2D	
-//--
-{
-// h2dWinArg->SetPIH2DWdg(this);
-h2dWinArg->SetCurrentBaseWdg(this);
-h2dWinArg->SetCurrentPIHisto2D(this->GetPIHisto());
-h2dWinArg->SetMsgParent((PIMsgHandler*)this);
-if(!h2dWinArg->Visible()) h2dWinArg->Show();
-}
-
-//++
-void PIH2DWdg::But3Press(int x, int y)
-//
-//	Gestion de l'utilisation du bouton-3 de la souris.
-//	Un seul objet est cree pour tous les histogrammes 2D.
-//	Il est connecte a un histogramme donnee par l'action du
-//	du bouton-3 de la souris dans la fenetre contenant
-//	le dessin de l'histogramme (cf H2WinArg::H2WinArg).
-//--
-{
-ActivateSpecializedControls();
-if(dbg) printf("PIH2DWdg::But3Press(%d,%d) h2dWinArg=%p\n"
-              ,x,y,h2dWinArg);
-}
-*/
 
 /////////////////////////////////////////////////////////////////
Index: /trunk/SophyaPI/PIext/pihisto2d.h
===================================================================
--- /trunk/SophyaPI/PIext/pihisto2d.h	(revision 1882)
+++ /trunk/SophyaPI/PIext/pihisto2d.h	(revision 1883)
@@ -67,22 +67,4 @@
 
 ////////////////////////////////////////////////////////////////////
-/*
-// NOT USED ANYMORE... KEEP IT FOR MEMORY
-class PIH2DWdg : public PIScDrawWdg {
-public:
-  PIH2DWdg(PIContainerGen *par,const char *nom,int sx=300,int sy=300,int px=0,int py=0);
-  ~PIH2DWdg();
-  void SetHisto(Histo2D* histo);
-  void SetPIHisto(PIHisto2D* pih2);
-  inline PIHisto2D* GetPIHisto() {return mPih;}
-  virtual string GetClickText(double x, double y); 
-  virtual void	 ActivateSpecializedControls(); // Pour activer des controles specifiques
-  virtual void   But3Press(int x, int y);
-protected:
-  PIHisto2D*  mPih;
-};
-*/
-
-////////////////////////////////////////////////////////////////////
 class H2WinArg : public PIWindow {
 public :