Index: /trunk/SophyaPI/PI/pidrawer.cc
===================================================================
--- /trunk/SophyaPI/PI/pidrawer.cc	(revision 1883)
+++ /trunk/SophyaPI/PI/pidrawer.cc	(revision 1884)
@@ -534,5 +534,5 @@
 
 void
-PIDrawer::GetClickInfo(string& info, double x, double y)
+PIDrawer::GetClickInfo(string& info,double x,double y,double x0,double y0,bool fgdiff)
 {
 }
Index: /trunk/SophyaPI/PI/pidrawer.h
===================================================================
--- /trunk/SophyaPI/PI/pidrawer.h	(revision 1883)
+++ /trunk/SophyaPI/PI/pidrawer.h	(revision 1884)
@@ -44,5 +44,6 @@
 
 // Renvoie une information liee au drawer pour une position x,y 
-  virtual void       GetClickInfo(string& info, double x, double y); 
+  virtual void       GetClickInfo(string& info,double x,double y
+                                 ,double x0=0.,double y0=0.,bool fgdiff=false); 
 
   virtual void       Refresh();      // Recalcule les limites et reaffiche
Index: /trunk/SophyaPI/PI/piscdrawwdg.cc
===================================================================
--- /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 1883)
+++ /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 1884)
@@ -242,17 +242,17 @@
 // Donne le texte a afficher pour position x,y  
 {
-  char buff[128];
+  char buff[64];
   PIDrawer*  dr = GetActiveDrawer();
-  strcpy(buff,"X= ");  sprintf(buff+3, mFormatOpt[0].c_str(), x);
-  info += buff;
-  strcpy(buff," Y= ");  sprintf(buff+4, mFormatOpt[1].c_str(), y);
-  if (mFgDeltaPos) 
-    sprintf(buff+strlen(buff)," (dX=%g, dY=%g)", 
-	    x-mPosForDelta[0], y-mPosForDelta[1]); 
-  info += buff;
+
+  info+="X=";  sprintf(buff,mFormatOpt[0].c_str(),x); info += buff;
+  info+=" Y="; sprintf(buff,mFormatOpt[1].c_str(),y); info += buff;
+  if(mFgDeltaPos) {
+    sprintf(buff," (dX=%g, dY=%g)",x-mPosForDelta[0],y-mPosForDelta[1]); 
+    info += buff;
+  }
 
   if (dr) {
-    info += "  ";  info += dr->Name();
-    dr->GetClickInfo(info, x, y);
+    info += " ";  // info += dr->Name();
+    dr->GetClickInfo(info,x,y,mPosForDelta[0],mPosForDelta[1],mFgDeltaPos);
   }
   return;
@@ -362,4 +362,9 @@
   else SelPointerShape(PI_ArrowPointer);
   if (mFgDeltaPos)  DrawDeltaPosMarker();
+  if (mFgReticule || mFgDeltaPos) {
+    mWGrC->SelForeground(cForCol);
+    mWGrC->SelGOMode(cGOmod);
+    mWGrC->SelLine(cLatt);
+  }
   if (mTrW)  mTrW->Hide();
 }
Index: /trunk/SophyaPI/PI/piscdrawwdg.h
===================================================================
--- /trunk/SophyaPI/PI/piscdrawwdg.h	(revision 1883)
+++ /trunk/SophyaPI/PI/piscdrawwdg.h	(revision 1884)
@@ -67,5 +67,5 @@
                                             // concernant le petit pave autour de la pos. courante 
 
-  void               SetTextWin(PILabel * tw, bool trw=true, int tx=500, int ty=30);
+  void               SetTextWin(PILabel * tw, bool trw=true, int tx=600, int ty=30);
 
   virtual void       But1Press(int x, int y);
Index: /trunk/SophyaPI/PIext/pihisto2d.cc
===================================================================
--- /trunk/SophyaPI/PIext/pihisto2d.cc	(revision 1883)
+++ /trunk/SophyaPI/PIext/pihisto2d.cc	(revision 1884)
@@ -351,21 +351,33 @@
 
 //++
-void PIHisto2D::GetClickInfo(string& info, double x, double y)
+void PIHisto2D::GetClickInfo(string& info,double x,double y,double x0,double y0,bool fgdiff)
 //
 //	Info specifique du drawer pour la position x,y
 //--
 {
-  Histo2D* h = Histogram();
-  if (h == NULL) return;
-  int i,j;
-  char str[128];
-
-  h->FindBin(x,y,i,j);
-  if(i<0 || i>=h->NBinX() || j<0 || j>=h->NBinY()) info += " ???";
-  else {
-    sprintf(str," v= %g",(*h)(i,j));
-    info += str;
+Histo2D* h = Histogram();
+if(h == NULL) return;
+
+int i,j;
+h->FindBin(x,y,i,j);
+if(i>=0 && i<h->NBinX() && j>=0 && j<h->NBinY()) {
+  char str[64];
+  if(fgdiff) {
+    int i0,j0;
+    h->FindBin(x0,y0,i0,j0);
+    if(i0>=0 && i0<h->NBinX() && j0>=0 && j0<h->NBinY()) {
+      sprintf(str," DV=%g",(*h)(i,j)-(*h)(i0,j0));
+      info += str;
+    } else {
+      info += " DV=?";
+    }
   }
-  return;
+  sprintf(str," V=%g",(*h)(i,j));
+  info += str;
+} else {
+  info += " V=?";
+}
+
+return;
 }
 
Index: /trunk/SophyaPI/PIext/pihisto2d.h
===================================================================
--- /trunk/SophyaPI/PIext/pihisto2d.h	(revision 1883)
+++ /trunk/SophyaPI/PIext/pihisto2d.h	(revision 1884)
@@ -32,5 +32,7 @@
   //   AppendTextInfo a faire un jour - Reza 21/01/2002 
   //  virtual void AppendTextInfo(string& info, double xmin, double ymin, double xmax, double ymax);
-  virtual void GetClickInfo(string& info, double x, double y); // Info pour position X,Y
+
+  virtual void GetClickInfo(string& info, double x, double y
+                           ,double x0=0.,double y0=0.,bool fgdiff=false); 
 
   virtual void UpdateLimits();