Index: trunk/SophyaPI/PI/pigraphgen.h
===================================================================
--- trunk/SophyaPI/PI/pigraphgen.h	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphgen.h	(revision 1890)
@@ -90,5 +90,5 @@
   { _lwidth=b._lwidth; _ldash=b._ldash; _ljoincap=b._ljoincap; }
  
-  explicit PILineAtt(PILineTypes ltyp);
+  PILineAtt(PILineTypes ltyp);
 
   inline ~PILineAtt() {}
@@ -99,11 +99,11 @@
   { *this=PILineAtt(ltyp);  return(*this); }
    
-  inline bool operator == (PILineAtt const& b)
+  inline bool operator == (PILineAtt const& b) const
   { return ((_lwidth==b._lwidth)&&(_ldash==b._ldash)&&(_ljoincap==b._ljoincap)); }
-  inline bool operator == (PILineTypes ltyp)
+  inline bool operator == (PILineTypes ltyp) const
   { return ((*this) == PILineAtt(ltyp)); }
-  inline bool operator != (PILineAtt const& b)
+  inline bool operator != (PILineAtt const& b) const
   { return ((_lwidth!=b._lwidth)||(_ldash!=b._ldash)||(_ljoincap!=b._ljoincap)); }
-  inline bool operator != (PILineTypes ltyp)
+  inline bool operator != (PILineTypes ltyp) const
   { return ((*this) != PILineAtt(ltyp)); }
 
@@ -183,6 +183,7 @@
   virtual void       SelBackground(PIColorMap& cmap, int cid)                  = 0;
   virtual void       SelGOMode(PIGOMode mod=PI_GOCopy)                         = 0;
-  virtual void       SelLine(PILineAtt att=PI_NormalLine)                      = 0;
-  inline  void       SelLine(PILineTypes lt) { SelLine(PILineAtt(lt)); }
+  virtual void       SelLine(PILineAtt const& att)                             = 0;
+  inline  void       SelLine(PILineTypes lt=PI_NormalLine) 
+                             { SelLine(PILineAtt(lt)); }
   virtual void       SelMarker(int msz=3, PIMarker mrk=PI_DotMarker)           = 0;
   virtual void       SelArrowMarker(int arrsz=5, 
Index: trunk/SophyaPI/PI/pigraphmac.cc
===================================================================
--- trunk/SophyaPI/PI/pigraphmac.cc	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphmac.cc	(revision 1890)
@@ -434,5 +434,5 @@
 
 /* --Methode-- */
-void PIGraphicMac::SelLine(PILineAtt att)
+void PIGraphicMac::SelLine(PILineAtt const & att)
 {
   if (mPane->FocusDraw()) {
Index: trunk/SophyaPI/PI/pigraphmac.h
===================================================================
--- trunk/SophyaPI/PI/pigraphmac.h	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphmac.h	(revision 1890)
@@ -48,5 +48,5 @@
                              PIFontAtt att=PI_RomanFont);
   virtual void       SelFontSzPt(int npt=12, PIFontAtt att=PI_RomanFont);
-  virtual void       SelLine(PILineAtt att=PI_NormalLine);
+  virtual void       SelLine(PILineAtt const& att);
   virtual void       SelMarker(int msz=3, PIMarker mrk=PI_DotMarker);
 
Index: trunk/SophyaPI/PI/pigraphps.cc
===================================================================
--- trunk/SophyaPI/PI/pigraphps.cc	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphps.cc	(revision 1890)
@@ -85,5 +85,5 @@
 SelBackground(PI_White);
 mLAtt = PI_ThinLine;
-SelLine();
+SelLine(PI_NormalLine);
 // mFAtt = PI_BoldFont;  mFSize = 0;  $CHECK$ Plus besoin 
 SelFont();
@@ -396,5 +396,5 @@
 
 /* --Methode-- */
-void PIGraphicPS::SelLine(PILineAtt att)
+void PIGraphicPS::SelLine(PILineAtt const& att)
 {
 mLAtt = att;
Index: trunk/SophyaPI/PI/pigraphps.h
===================================================================
--- trunk/SophyaPI/PI/pigraphps.h	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphps.h	(revision 1890)
@@ -47,5 +47,5 @@
   virtual void       SelBackground(PIColorMap& cmap, int cid);
   virtual void       SelGOMode(PIGOMode mod=PI_GOCopy);
-  virtual void       SelLine(PILineAtt att=PI_NormalLine);
+  virtual void       SelLine(PILineAtt const& att);
   virtual void       SelMarker(int msz=3, PIMarker mrk=PI_DotMarker);
 
Index: trunk/SophyaPI/PI/pigraphuc.cc
===================================================================
--- trunk/SophyaPI/PI/pigraphuc.cc	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphuc.cc	(revision 1890)
@@ -787,5 +787,5 @@
 
 /* --Methode-- */
-void PIGraphicUC::SelLine(PILineAtt att)
+void PIGraphicUC::SelLine(PILineAtt const& att)
 {
   if (!mGrC) return;
Index: trunk/SophyaPI/PI/pigraphuc.h
===================================================================
--- trunk/SophyaPI/PI/pigraphuc.h	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphuc.h	(revision 1890)
@@ -74,5 +74,5 @@
   virtual void       SelBackground(PIColorMap& cmap, int cid);
   virtual void       SelGOMode(PIGOMode mod=PI_GOCopy);
-  virtual void       SelLine(PILineAtt att=PI_NormalLine);
+  virtual void       SelLine(PILineAtt const& att);
   virtual void       SelMarker(int msz=3, PIMarker mrk=PI_DotMarker);
 
Index: trunk/SophyaPI/PI/pigraphx.cc
===================================================================
--- trunk/SophyaPI/PI/pigraphx.cc	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphx.cc	(revision 1890)
@@ -68,5 +68,5 @@
 mLAtt = PI_NotDefLineAtt;
  XSetFont(mDisp, DefGC(), myFont.GetXFontId());  // Pour initialiser la fonte ds le GC 
-SelLine();
+SelLine(PI_NormalLine);
 SelMarker(1, PI_DotMarker);  
 mFCfMap = colpix[PI_Black];  mBCfMap = colpix[PI_White];
@@ -470,5 +470,5 @@
 
 /* --Methode-- */
-void PIGraphicX::SelLine(PILineAtt att)
+void PIGraphicX::SelLine(PILineAtt const& att)
 {
 
Index: trunk/SophyaPI/PI/pigraphx.h
===================================================================
--- trunk/SophyaPI/PI/pigraphx.h	(revision 1888)
+++ trunk/SophyaPI/PI/pigraphx.h	(revision 1890)
@@ -47,5 +47,5 @@
   virtual void       SelBackground(PIColorMap& cmap, int cid);
   virtual void       SelGOMode(PIGOMode mod=PI_GOCopy);
-  virtual void       SelLine(PILineAtt att=PI_NormalLine);
+  virtual void       SelLine(PILineAtt const& att);
   virtual void       SelMarker(int msz=3, PIMarker mrk=PI_DotMarker);
 